import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class Main extends MIDlet implements CommandListener {
  public static Main midlet;
  private static Display display;
  private static Form form;
  private static Command ok;
  private static TextField cmLine;
  public static StringItem console;
  // public static StringBuffer console = new StringBuffer();
  public static CommandShell shell = new CommandShell();

  public Main() {
    midlet = Main.this;
    display = Display.getDisplay(Main.this);
    console = new StringItem("Console", "");
    console.setFont(Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));
    cmLine = new TextField(null, "", 255, TextField.ANY);
    ok = new Command("Exec", 4, 2);

    form = new Form("Console");
    form.append(console);
    form.append(cmLine);
    form.addCommand(ok);
    form.setCommandListener(Main.this);

  }

  public void startApp() {
    display.setCurrent(form);
  }

  public static void print(String text) {
    // console.append(text);
    console.setText(Main.console.getText() + text);
  }

  public static void alert(String text) {
    Alert alert = new Alert("Test", text, null, AlertType.INFO);
    alert.setTimeout(Alert.FOREVER);
    display.setCurrent(alert);
  }

  public static String loadSource(String[] args) throws Exception {
    if (args.length != 1) throw new Exception("Usage: exec <filename>");

    String source = args[0];
    if (source.charAt(0) != '/') source = "/" + source;
    InputStream is = Runtime.getRuntime().getClass().getResourceAsStream(source);
    StringBuffer sb = new StringBuffer();
    int ch = 0;
    try {
      while ((ch = is.read()) != -1) {
        sb.append((char)((ch >= 0xc0 && ch <= 0xFF) ? (ch + 0x350) : ch));
      }
      is.close();
      return sb.toString();
    } catch(IOException ioe) {
      return null;
    }

  }

  public void pauseApp() {}

  public void destroyApp(boolean flag) {}

  public void commandAction(Command command, Displayable displayable) {
    if (command == ok && cmLine.size() > 0) {
      print(">\\" + cmLine.getString() + "\n");
      shell.exec(cmLine.getString());
      cmLine.setString("");
    }
  }

}