package liket.engine;
/**
 *
 * @author Жалол
 */

import liket.engine.work.Work;
import liket.engine.work.WorkListener;
import liket.util.TextUtil;
import java.util.Enumeration;
import java.util.Vector;

public abstract class Engine implements WorkListener {
  public Vector vWorks;
  public Library library;

  public void init() {
    vWorks = new Vector();
  }

  public void shutDown() {
    Enumeration enumeration = vWorks.elements();
    while (enumeration.hasMoreElements())((Work) enumeration.nextElement()).stop();
    vWorks = null;
  }

  // @Override
  public void error(String error, Work sender) {
    sender.stop();
    vWorks.removeElement(sender);
    System.out.println(error);
  }

  public void exec(String str) {
    Work work = new Work();
    vWorks.addElement(work);

    work.setLibrary(library);
    work.execute(TextUtil.split(str, "\n"));
  }
}